from typing import *

__version__ = "1.0.0"


class Calculator():
    """Create the init which also sets the default state of
       every instance to 0. The state of the Calc Instance
       can be specified through an optional argument.
       
       Every instantiated object of the class can be altered through 
       the operand methods that will apply the given numeric argument.
       After the operation the state of the value will change and
       stay in memory until cleared (with its own method).
    """
    
    def __init__(self, state: float =0):     #Initiate an Object with a starting val
        self.state = state
    
    
    def __repr__(self):                      #represents Class obj as str when printed
        return str(self.state)
    
    
    """Now we create the different operand types: +, -, *, / and x^(1/n)
       Simply apply the mathematical operation and set the renew the state
       of the instance value variable.
    """
    
    
    def add(self, term: float) -> float:
        sum = self.state + term
        self.state = sum
        
        return sum    
    
    def subtract(self, term: float) -> float:
        difference = self.state - term
        self.state = difference
        
        return difference
    
    
    def multiply(self, term: float) -> float:
        product = self.state * term
        self.state = product
        
        return product
    
    
    def divide(self, term: float):
        if term == 0:
            return ("Can't divide by Zero!")    #Not allowing illegal operations
            
        quotient = self.state / term
        self.state = quotient
        
        return quotient
    
    
    def root(self, n: float):                   #Not allowing illegal operations
        if self.state < 0:
            return "Cant take the root of a negative number!"
        elif n == 0:
            return "Can't take the 0th root!"
        
        n_th_root = self.state ** (1/n)
        self.state = n_th_root
        
        return n_th_root
    
    
    def clear(self) -> None:                 #Method for cleaning the calcs memory
        self.state = 0
        
        

